
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java ArrayList的不同排序方法_java / iVAN</title>

    <meta name="description" content="Java ArrayList的不同排序方法_java 由于其功能性和灵活性,ArrayList是 Java 集合框架中使用最为普遍的集合类之一.ArrayList 是一种 List 实现,它的内部用一个动态数组来存储元素,因此 ArrayList 能够在添加和移除元素的时候进行动态的扩展和缩减.你可能已经使用过 ArrayList,因此我将略过基础部分.如果你对 ArrayList 还不熟悉,你可以参考它的 API 文档,可以很容易理解在 ArrayList 上执行基本的操作. 在这篇文章中,我将讨论 ArrayList 中一种极其重要的操作,你很">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java ArrayList的不同排序方法_java</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>由于其功能性和灵活性，ArrayList是 Java 集合框架中使用最为普遍的集合类之一。ArrayList 是一种 List 实现，它的内部用一个动态数组来存储元素，因此 ArrayList 能够在添加和移除元素的时候进行动态的扩展和缩减。你可能已经使用过 ArrayList，因此我将略过基础部分。如果你对 ArrayList 还不熟悉，你可以参考它的 API 文档，可以很容易理解在 ArrayList 上执行基本的操作。<br />
在这篇文章中，我将讨论 ArrayList 中一种极其重要的操作，你很有可能需要在企业应用开发中实现它。它就是 ArrayList 元素的排序。</p>
<p><strong>排序字符串对象的ArrayList</strong></p>
<p>考虑一个 ArrayList 存储着以字符串形式存在的国名（country name），为了对这个 ArrayList 进行排序，你需要调用 Collections.sort()方法，传递由国名构成的 ArrayList 对象。这种方法将按照自然顺序（按字母升序）对元素（国名）进行排序。让我们为此来写一段代码。<br /><strong>SortArrayListAscendingDescending.java</strong></p>
<pre>
package guru.springframework.blog.sortarraylist.ascendingdescending;
 import java.util.ArrayList;
 import java.util.Collections;
 public class SortArrayListAscendingDescending {
 private ArrayList arrayList;
 public SortArrayListAscendingDescending(ArrayList arrayList) {
 this.arrayList = arrayList;
 }
 public ArrayList getArrayList() {
 return this.arrayList;
 }
 public ArrayList sortAscending() {
 Collections.sort(this.arrayList);
 return this.arrayList;
 }
 public ArrayList sortDescending() {
 Collections.sort(this.arrayList, Collections.reverseOrder());
 return this.arrayList;
 }
 }</pre>
<p>在上面的类中，我们在构造器中初始化了一个 ArrayList 对象。在 sortAscending()方法中，我们调用了 Collections.sort()方法，并传递这个初始化的 ArrayList对象为参数，返回排序后的 ArrayList。在 sortDescending()方法中，我们调用重载的 Collections.sort()方法让其按照降序对元素排序，这个版本的 Collections.sort()接收ArrayList对象作为第一个参数，一个由 Collections.reverseOrder()方法返回的 Comparator 对象作为第二个参数。我们将会在稍后讲解 Comparator。为了测试排序功能，我们将写一段测试代码。<br /><strong>SortArrayListAscendingDescendingTest.java</strong></p>
<pre>
package guru.springframework.blog.sortarraylist.ascendingdescending;
 import org.junit.Test;
 import java.util.ArrayList;
 import static org.junit.Assert.*;
 public class SortArrayListAscendingDescendingTest {
 &lt;a href="http://www.jobbole.com/members/madao"&gt;@Test&lt;/a&gt;
 public void testSortAscendingDescending() throws Exception {
 ArrayList countryList = new ArrayList&lt;&gt;();
 countryList.add("France");
 countryList.add("USA");
 countryList.add("India");
 countryList.add("Spain");
 countryList.add("England");
 SortArrayListAscendingDescending sortArrayList = new SortArrayListAscendingDescending(countryList);
 ArrayList unsortedArrayList = sortArrayList.getArrayList();
 System.out.println("Unsorted ArrayList: " + unsortedArrayList);
 ArrayList sortedArrayListAscending = sortArrayList.sortAscending();
 System.out.println("Sorted ArrayList in Ascending Order : " + sortedArrayListAscending);
 ArrayList sortedArrayListDescending = sortArrayList.sortDescending();
 System.out.println("Sorted ArrayList in Descending Order: " + sortedArrayListDescending);
 }
 }</pre>
<p>在上面的测试代码中，我们创建一个 ArrayList 对象，并添加了 5 个字符串对象代表 5 个国家的名字。然后我们调用 getArrayList()、sortAscending()和 sortDescending()方法，并打印这些方法返回的 ArrayList 对象。</p>
<p>到目前为止，所要排序的 ArrayList 元素都是非常简单的，我们仅仅只是调用 Collections.sort()方法并传递了需要排序的 ArrayList 对象作为参数。但是更多的是你会遇到一些复杂的情景下对 ArrayList 进行排序。<br />
Collections.sort() 方法对 ArrayList 的元素或者任何其他 List 的实现提供的可比较的元素进行排序，这意味着这些元素的类需要实现 java.lang 包中的 Comparable 接口。正如 String 类实现了 Comparable 接口，我们就可以对由国名构成的 ArrayList 排序。有些其他的标准 Java 类实现了 Comparable 接口，包括原始的包装类，例如 Integer、Short、Double、Float、Boolean、BigInteger、BigDecimal、File 和 Date 类都实现了 Comparable 接口。</p>
<p><strong>使用Comparable排序ArrayList</strong></p>
<p>Comparable 是带有单一 compareTo()方法的接口。一个实现了 Comparable 接口的类对象可以与其它同类型的对象进行比较，实现 Comparable 接口的类需要重写 compareTo()方法，这个方法接收一个同类型的对象，并实现这个对象和传递给方法的另一个对象比较的逻辑。compareTo()方法返回Int类型的比较结果，分别代表下面的含义：<br />
正值表示当前对象比传递给 comPareTO()的对象大<br />
负值表示当前对象比传递给 comPareTO()的对象小<br />
零表示两个对象相等<br />
让我们来举一个例子，JobCandidate 类的对象保存在 ArrayList 中并准备对其进行排序。JobCandidate 类有三个成员变量：字符串类型的姓名和性别、整型的年龄。我们想要对保存在 ArrayList 中的 JobCandidate 对象按照年龄进行排序。因此我们要让 JobCandidate 类实现 Comparable 接口并重写 compareTo()方法。<br />
JobCandidate类的代码如下：<br /><strong>JobCandidate.java</strong></p>
<pre>
package guru.springframework.blog.sortarraylist.comparable;
 public class JobCandidate implements Comparable {
 private String name;
 private String gender;
 private int age;
 public JobCandidate(String name, String gender, int age) {
 this.name = name;
 this.gender = gender;
 this.age = age;
 }
 public String getName() {
 return name;
 }
 public String getGender() {
 return gender;
 }
 public int getAge() {
 return age;
 }
 @Override
 public int compareTo(JobCandidate candidate) {
 return (this.getAge() &lt; candidate.getAge() ? -1 :
 (this.getAge() == candidate.getAge() ? 0 : 1));
 }
 @Override
 public String toString() {
 return " Name: " + this.name + ", Gender: " + this.gender + ", age:" + this.age;
 }
 }</pre>
<p>在上面 JobCandidate 类被重写的 compareTo()方法中，我们实现了基于年龄的比较逻辑。我见过很多程序员将(this.getAge() – candidate.getAge())作为返回的比较结果。尽管使用这种 return 语句看上去似乎很吸引人，并且也不会对我们的例子造成影响，我的建议是远离这种语句。想象一下，比较整数值，其中有一个或者两个都是负数的结果。这会导致一些错误，让你的程序行为不定，而且更重要的是，这样的错误是很细微的，尤其是在大型的企业应用中很难检测出来。下面我们将写一个辅助类，为委托方对包含了 JobCandidate 元素的 ArrayList 对象进行排序。<br /><strong>JobCandidateSorter.java</strong></p>
<pre>
package guru.springframework.blog.sortarraylist.comparable;
import java.util.ArrayList;
 import java.util.Collections;
 public class JobCandidateSorter {
 ArrayList jobCandidate = new ArrayList&lt;&gt;();
 public JobCandidateSorter(ArrayList jobCandidate) {
 this.jobCandidate = jobCandidate;
 }
 public ArrayList getSortedJobCandidateByAge() {
 Collections.sort(jobCandidate);
 return jobCandidate;
 }
 }
</pre>
<p>在 JobCandidateSorter 类中，我们初始化了一个 ArrayList 对象，委托方将通过构造函数实例化 JobCandidateSorter 。然后我们编写了 getSortedJobCandidateByAge()方法，在这个方法中，我们调用 Collections.sort()并传递已经初始化了的 ArrayList 为参数，最后返回排序后的 ArrayList。<br />
接下来，我们写一个测试类来测试一下我们的代码。<br /><strong>JobCandidateSorterTest.java</strong></p>
<pre>
 package guru.springframework.blog.sortarraylist.comparable; import org.junit.Test;
 import java.lang.reflect.Array;
 import java.util.ArrayList;
 import static org.junit.Assert.*;
 public class JobCandidateSorterTest {
 &lt;a href="http://www.jobbole.com/members/madao"&gt;@Test&lt;/a&gt;
 public void testGetSortedJobCandidateByAge() throws Exception {
 JobCandidate jobCandidate1 = new JobCandidate("Mark Smith", "Male", 26);
 JobCandidate jobCandidate2 = new JobCandidate("Sandy Hunt", "Female", 23);
 JobCandidate jobCandidate3 = new JobCandidate("Betty Clark", "Female", 20);
 JobCandidate jobCandidate4 = new JobCandidate("Andrew Styne", "Male", 24);
 ArrayList jobCandidateList = new ArrayList&lt;&gt;();
 jobCandidateList.add(jobCandidate1);
 jobCandidateList.add(jobCandidate2);
 jobCandidateList.add(jobCandidate3);
 jobCandidateList.add(jobCandidate4);
 JobCandidateSorter jobCandidateSorter = new JobCandidateSorter(jobCandidateList);
 ArrayList sortedJobCandidate = jobCandidateSorter.getSortedJobCandidateByAge();
 System.out.println("-----Sorted JobCandidate by age: Ascending-----");
for (JobCandidate jobCandidate : sortedJobCandidate) {
 System.out.println(jobCandidate);
 }
 }
 }</pre>
<p>在上面的测试类中，我们创建了四个 JobCandidate 对象并把它们添加到 ArrayList，然后传递这个 ArrayList 到构造函数来实例化 JobCandidateSorter 类。最后，我们调用 JobCandidateSorter 类的 getSortedJobCandidateByAge()方法，并打印这个方法返回的排序后的 ArrayList。</p>
<p>使用 Comparable 对 ArrayList 排序是一种常用的方法。但是你必须知道有某些限制。你想要排序的对象的类必须实现 Comparable 并覆写 compareTo()方法。这基本上意味着你将只能基于一个成员变量来比较对象(我们例子中的年龄字段)。如果要求你按照姓名和年龄来对 JobCandidate 对象进行排序怎么办？ Comparable 就不是解决的方法了。另外，比较逻辑是需要进行比较的对象的类的一部分，它消除了比较逻辑可复用性的可能。Java 通过使用在 java.util 包下提供的Comparator接口解决了上述的比较需求。</p>
<p><strong>使用 Comparator 排序 ArrayList</strong></p>
<p>Comparator 接口与Comparable 接口相似也提供了一个单一的比较方法叫作 compare()。然而，与 Comparable的 compareTo()方法不同的是，这个 compare()接受两个同类型的不同对象进行比较。<br />
我们将用 Comparator 对我们之前使用过的相同 JobCandidate 类对象进行排序。我们将通过实现 Comparatoras 匿名内部类，允许对 JobCandidate 对象按照年龄和姓名进行排序。<br />
下面是使用了 Comparator 的 JobCandidate 类代码<br /><strong>JobCandidate.java</strong></p>
<pre>
package guru.springframework.blog.sortarraylist.comparator;
 import java.util.Comparator;
 public class JobCandidate {
 private String name;
 private String gender;
 private int age;
 public JobCandidate(String name, String gender, int age) {
 this.name = name;
 this.gender = gender;
 this.age = age;
 }
 public String getName() {
 return name;
 }
 public String getGender() {
 return gender;
 }
 public int getAge() {
 return age;
 }
 public static Comparator ageComparator = new Comparator() {
 @Override
 public int compare(JobCandidate jc1, JobCandidate jc2) {
 return (jc2.getAge() &lt; jc1.getAge() ? -1 :
 (jc2.getAge() == jc1.getAge() ? 0 : 1));
 }
 };
 public static Comparator nameComparator = new Comparator() {
 @Override
 public int compare(JobCandidate jc1, JobCandidate jc2) {
 return (int) (jc1.getName().compareTo(jc2.getName()));
 }
 };
 @Override
 public String toString() {
 return " Name: " + this.name + ", Gender: " + this.gender + ", age:" + this.age;
 }
 }
</pre>
<p>在上面的类中，从 29 行到 35 行，我们写了一个匿名类并实现了 compare()方法，按照年龄的降序对 JobCandidate 对象进行排序。从37行到42行，我们又写了一个匿名类并实现了 compare() 方法，按照姓名的升序对 JobCandidate进行排序。现在我们写一个类，为委托方对 ArrayList 的元素进行排序。<br /><strong>JobCandidateSorter.java</strong></p>
<pre>
package guru.springframework.blog.sortarraylist.comparator;
 import java.util.ArrayList;
 import java.util.Collections;
 public class JobCandidateSorter {
 ArrayList jobCandidate = new ArrayList&lt;&gt;();
 public JobCandidateSorter(ArrayList jobCandidate) {
 this.jobCandidate = jobCandidate;
 }
 public ArrayList getSortedJobCandidateByAge() {
 Collections.sort(jobCandidate, JobCandidate.ageComparator);
 return jobCandidate;
 }
 public ArrayList getSortedJobCandidateByName() {
 Collections.sort(jobCandidate, JobCandidate.nameComparator);
 return jobCandidate;
 }
 }</pre>
<p>在上面的类中，我们写了 getSortedJobCandidateByAge()方法，在这个方法内部我们调用了 Collections.sort()的重载版本，这个版本传递要被排序的 ArrayList 对象和比较年龄的 Comparator 对象。在 getSortedJobCandidateByName()方法内部，我们又调用了 Collections.sort()的另一个重载版本，这个版本传递要被排序的 ArrayList 对象和比较姓名的 Comparator 对象。<br />
Let's write a test class to test our code.<br />
让我们写一个测试类来测试我们的代码。<br /><strong>JobCandidateSorterTest.java</strong></p>
<pre>
package guru.springframework.blog.sortarraylist.comparator;
 import guru.springframework.blog.sortarraylist.comparator.JobCandidate;
 import guru.springframework.blog.sortarraylist.comparator.JobCandidateSorter;
 import org.junit.Before;
 import org.junit.Test;
 import java.util.ArrayList;
 import static org.junit.Assert.*;
 public class JobCandidateSorterTest {
 JobCandidateSorter jobCandidateSorter;
 @Before
 public void setUp() throws Exception {
 JobCandidate jobCandidate1 = new JobCandidate("Mark Smith", "Male", 26);
 JobCandidate jobCandidate2 = new JobCandidate("Sandy Hunt", "Female", 23);
 JobCandidate jobCandidate3 = new JobCandidate("Betty Clark", "Female", 20);
 JobCandidate jobCandidate4 = new JobCandidate("Andrew Styne", "Male", 24);
 ArrayList jobCandidateList = new ArrayList&lt;&gt;();
 jobCandidateList.add(jobCandidate1);
 jobCandidateList.add(jobCandidate2);
 jobCandidateList.add(jobCandidate3);
 jobCandidateList.add(jobCandidate4);
 jobCandidateSorter = new JobCandidateSorter(jobCandidateList);
 }
 &lt;a href="http://www.jobbole.com/members/madao"&gt;@Test&lt;/a&gt;
 public void testGetSortedJobCandidateByAge() throws Exception {
 System.out.println("-----Sorted JobCandidate by age: Descending-----");
ArrayList sortedJobCandidate = jobCandidateSorter.getSortedJobCandidateByAge();
 for (JobCandidate jobCandidate : sortedJobCandidate) {
 System.out.println(jobCandidate);
 }
 }
 &lt;a href="http://www.jobbole.com/members/madao"&gt;@Test&lt;/a&gt;
 public void testGetSortedJobCandidateByName() throws Exception {
 System.out.println("-----Sorted JobCandidate by name: Ascending-----");
ArrayList sortedJobCandidate = jobCandidateSorter.getSortedJobCandidateByName();
 for (JobCandidate jobCandidate : sortedJobCandidate) {
 System.out.println(jobCandidate);
 }
 }
 }</pre>
<p>在测试类中我们向 ArrayList 中添加若干 JobCandidate 对象，并使用 Before 注释在测试单元的 setup()方法中创建了一个 JobCandidateSorter 对象。如果你是一个 Junit 新手，可以参考我以前的文章包括 Junit 注释（Junit 单元测试系列）。在 testGetSortedJobCandidateByAge()测试方法中我们调用了 getSortedJobCandidateByAge()方法，并打印了该方法返回的排序后的 ArrayList。在 testGetSortedJobCandidateByName()测试方法中我们调用了getSortedJobCandidateByName()方法并同样打印该方法返回的 ArrayList。</p>
<p>在本文中我们看到了 ArrayList 排序的不同方法。一种是使用 Comparable 另一种是使用 Comparator。方法的选择一直是造成程序员们困惑的原因之一。你最应该记住的就是一个 Comparable 对象可以说“我可以自己与另外一个对象比较”而一个 Comparator 对象可以说“我可以比较两个不同的对象”。你不能说一个接口比另一个要好。选择的接口取决于你需要实现的功能。</p>
<p>以上就是本文的全部内容，希望对大家的学习有所帮助。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索java<br />
                    ，                arraylist<br />
                                    排序<br />
                                    java arraylist 排序、java对arraylist排序、java中arraylist排序、arraylist排序方法、java arraylist方法，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-05 05:48:57</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e6%8e%92%e5%ba%8f/" title="排序">排序</a>, <a href="https://www.iamivan.net/tag/arraylist/" title="arraylist">arraylist</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java ArrayList的不同排序方法_java的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWl74rp.html" rel="bookmark">Java ArrayList 的不同排序方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于其功能性和灵活性,ArrayList是 Java 集合框架中使用最为普遍的集合类之一.ArrayList 是一种 List 实现,它的内部用一个动态数组来存储元素,因此 ArrayList 能够在添加和移除元素的时候进行动态的扩展和缩减.你可能已经使用过 ArrayList,因此我将略过基础部分.如果你对 ArrayList 还不熟悉,你可以参考它的 API 文档,可以很容易理解在 ArrayList 上执行基本的操作. 在这篇文章中,我将讨论ArrayList中一种极其重要的操作,你很有可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5QOgqp.html" rel="bookmark">JAVA四种基本排序方法实例总结&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了JAVA四种基本排序方法.分享给大家供大家参考.具体如下: JAVA四种基本排序,包括冒泡法,插入法,选择法,SHELL排序法.其中选择法是冒泡法的改进,SHELL排序法是 插入法的改进.所以从根本上来说可以归纳为两种不同的排序方法:即:插入法&amp;冒泡法 一 插入法: 遍历排序集合,每到一个元素时,都要将这个元素与所有它之前的元素遍历比较一遍,让符合排序顺序的元素挨个移动到当前范围内它最应该出现的位置.交换是相邻遍历移动,双重循环控制实现.这种排序法属于地头蛇类型,在我的地牌上我要把			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44WENz.html" rel="bookmark">Java代码为例讲解堆的性质和基本操作以及排序方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				堆的性质堆是一棵完全二叉树,实际中可以通过一个数组来实现,它最重要的一个性质是:任意节点都小于(大于)等于其子节点.将根节点最小的堆称为最小堆,根节点最大的堆称为最大堆.下图给出了一个最大堆的示例及其数组表示,可以直观地看出每个节点都比它的孩子们都要大. 在上图中可以看到,完全二叉树的节点可以从根节点编号为1开始按顺序排列,对应数组A中的索引(注意此处下标是从1开始的).给定一个节点i,我们很容易可以得到它的左孩子是2i,右孩子是2i+1,父节点是i/2 堆的基本操作堆有两种基本操作(下面以最小			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkRWJM.html" rel="bookmark">Java解析Excel内容的方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Java解析Excel内容的方法.分享给大家供大家参考.具体实现方法如下: 复制代码 代码如下: import java.io.File;  import java.io.FileInputStream;  import java.io.InputStream;  import java.util.ArrayList;  import org.apache.poi.hssf.usermodel.HSSFWorkbook;  import org.apache.poi.ss.user			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDkPyBp.html" rel="bookmark">java实现mp3合并的方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了java实现mp3合并的方法.分享给大家供大家参考.具体实现方法如下: 复制代码 代码如下: package test; import java.io.*; import java.util.*; public class Test6 {     public static void main(String[] args) throws Exception     {         String s = &quot;D:/out.mp3&quot;; // 输出目录 &amp; 文件名  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ2vqkz.html" rel="bookmark">java实现日期拆分的方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了java实现日期拆分的方法.分享给大家供大家参考.具体如下: 如:计算6-1至6-5之间的日期天数及具体日期,预期的结果是得到: 6-1 6-2 6-3 6-4 6-5 以下是我利用java 日历类做的实现: Calendar canlandar1 = Calendar.getInstance();//开始时间 Calendar canlandar2 = Calendar.getInstance();//结束时间 canlandar1.setTime(psd);//2009-6-1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQr3jZM.html" rel="bookmark">Java获取mac地址的方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Java获取mac地址的方法.分享给大家供大家参考.具体如下: /* * GetMacAddress .java * * description:get Mac addreess * * @author hadeslee * * Created on 2007-9-27, 9:11:15 * * To change this template, choose Tools | Templates * and open the template in the editor. */ pa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQRw6z.html" rel="bookmark">Java实现MD5加密的方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Java实现MD5加密的方法.分享给大家供大家参考.具体实现方法如下: import java.security.MessageDigest; import java.security.NoSuchAlgorithmException; public class MD5HashUtil { private MessageDigest md = null; private static MD5HashUtil md5 = null; private static final char			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxYayRp.html" rel="bookmark">java执行Linux命令的方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了java执行Linux命令的方法.分享给大家供大家参考.具体实现方法如下: 复制代码 代码如下: public class StreamGobbler extends Thread {            InputStream is;      String type;        public StreamGobbler(InputStream is, String type) {          this.is = is;          this.type = ty			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMN79Wp.html" rel="bookmark" class="title">网速很慢怎么办？</a>
					<div>
						  我估计你不是网速慢,而是你的电脑的内存可能不够用了.你可以告诉我你的内存是多大吗,因为网速是不同于电脑速度的,只要你的宽带超过了1.5M(如果没有达到的话你就只有去电信多加些钱了)的话那就是电脑硬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8gaBM.html" rel="bookmark" class="title">谈Web标准中10个最经常犯的HTML标签错误</a>
					<div>
						请熟读并记下以下10条.这份列表包含了10个最经常犯的HTML标签错误,记下他们,能够让我们避免犯此常见错误,让我们的HTML标签符合语义,和标准的要求 罪行1:把块级元素放入了行内元素内   HTM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlgNab.html" rel="bookmark" class="title">使用JavaScript访问XML数据</a>
					<div>
						javascript|xml|访问|数据 以前做了java对xml文件的访问．后来听我的一个同事(技术很牛的哈)说:用javaScript 访问更方便简单．于是今天就回家找资料测试了下．确实很方便．欢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjrvWb.html" rel="bookmark" class="title">Photoshop鼠绘一个逼真的软件盒子包装</a>
					<div>
						软件盒子或包装盒是设计中最常用的素材,很多设计师都会收集大量的此类素材,但有时候我们需要制作一些特殊的软件盒子包装,哪就需要自己来制作了,本文介绍了制作软件盒子的方法,虽然很简单,相信对设计师都会有用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ5g2p.html" rel="bookmark" class="title">一步一个脚印 分享四段SEO求职经历</a>
					<div>
						笔者毕业于2011年,一走出校门笔者就踏入了SEO从业者的大军.然而走SEO这条路并不顺遂,刚开始就几经坎坷和波折,打击颇大,在应聘工作中最大的问题就是刚踏出校门的我们缺乏SEO从业经验.然而这一段艰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAY6Ob.html" rel="bookmark" class="title">Oracle技术：Linux 建立软raid</a>
					<div>
						1.Raid定义 RAID,全称Redundant Array of Inexpensive Disks,中文名为廉价磁盘冗余阵列.RAID可分为软RAID和硬RAID,软RAID是通过软件实现多块硬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxoGKb.html" rel="bookmark" class="title">office mac上的快捷键详解</a>
					<div>
						office mac上的快捷键详解   如有必要,按 Alt+F 和 T 打开&quot;Word 选项&quot;对话框,然后按向下键选择&quot;自定义功能区&quot;. 重复按 Tab 键直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOweB9z.html" rel="bookmark" class="title">PowerPoint2007设置每隔一分钟就自动保存方法图解教程</a>
					<div>
						看到过本文作者以前写过的有关Word和Excel每隔1分钟就自动保存文件的文章,就直接可以忽略本文了,因为Word.Excel和PPT的自动保存方法几乎是一模一样的,最多也就是名字叫法不同而已. 本文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8j3Q9b.html" rel="bookmark" class="title">jQuery获取上传文件的名称的正则表达式</a>
					<div>
						  在Web开发中,经常会涉及到文件上传.文件上传时通常都要验证文件的有效性,这个通常就要用正则表达式来判断. 方法一: ? 1 2 3 4 5 6 7 $('input[type=&quot;fil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e0QNb.html" rel="bookmark" class="title">jQuery实现表格颜色交替显示的方法</a>
					<div>
						 这篇文章主要介绍了jQuery实现表格颜色交替显示的方法,涉及jQuery操作表格样式的技巧,非常具有实用价值,需要的朋友可以参考下     本文实例讲述了jQuery实现表格颜色交替显示的方法.分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmakWz.html" rel="bookmark" class="title">如何关闭Win8无线网络</a>
					<div>
						  Windows 8系统添加了&quot;飞行模式&quot;这个功能--当我们开启Win8飞行模式时,会切断所有无线网络,但不会断开有线以太网.具体操作如下: 1.Win8系统中按下&quot;W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EmGXM.html" rel="bookmark" class="title">Win8系统下Lenovo G480机型IE10 的Flash插件无法使用</a>
					<div>
						故障现象: Win8系统机型使用IE浏览器播放在线视频出现:&quot;您还没有安装flash播放器,请点击这里安装&quot; 解决方案: 1. 进入IE浏览器,打开右上角工具(是个小齿轮的标记,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3505M.html" rel="bookmark" class="title">电脑显示器有波纹怎么办？</a>
					<div>
						  1.电磁干扰 最为常见的可能是笔记本接上电源会抖动,而不接电源则没事.这一般在工业用电上较易出现,你只需要更换一个电源适配器或将电源插头的地线剪掉即可; 2.用电影响 这种情况是,你接电脑的插座上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr5nAM.html" rel="bookmark" class="title">activeMQ到底是怎么个接受信息？</a>
					<div>
						问题描述 小弟初学,网上看了好几个例子,都千遍一律,如消息发送出去,消息如果被接受,通过什么中转站什么的?要如何配置?求详细一个步骤,感激不尽 问题补充:消息消费者:public void consu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV2L1b.html" rel="bookmark" class="title">arp-关于linux ARP 老化的问题</a>
					<div>
						问题描述 关于linux ARP 老化的问题 嵌入式设备为路由器,linux 3.10.现在想做一个功能是实时侦测当前在线的client (也就是电脑或手机). 本来想查看/proc/net/arp  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4Kvnz.html" rel="bookmark" class="title">新建maven环境，没有junit&colon;jar&colon;3&period;8&period;1 ，但是maven自己是依赖这个版本的</a>
					<div>
						问题描述 新建maven环境,没有junit:jar:3.8.1 ,但是maven自己是依赖这个版本的 新建了maven环境 打包的时候报Failed to execute goal org.apac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKnyDb.html" rel="bookmark" class="title">Linux Device Tree（二）：基本概念</a>
					<div>
						一.前言 一些背景知识(例如:为何要引入Device Tree,这个机制是用来解决什么问题的)请参考引入Device Tree的原因,本文主要是介绍Device Tree的基础概念. 简单的说,如果要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKemBb.html" rel="bookmark" class="title">雾里看花之 Python Asyncio</a>
					<div>
						从 Twisted 框架借鉴一些经验来理解 asynio 并非难事,但是,asyncio 包含众多的元素,我开始动摇,不知道如何将这些孤立的零碎拼图组合成一副完整的图画.我已没有足够的智力提出任何更好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRa01b.html" rel="bookmark" class="title">asp net c&num;-关于asp&period;net网站的问题</a>
					<div>
						问题描述 关于asp.net网站的问题 http://dict.youdao.com/m/search?keyfrom=dict.mresult&amp;q=table 类似这种只要从客户端发出一个数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXDL6b.html" rel="bookmark" class="title">浪潮胡雷钧： KNL&plus;FPGA是加速深度学习的黄金搭档</a>
					<div>
						8月17日,在美国旧金山举行的英特尔信息技术峰会(Intel Developer Forum,简称IDF)上,浪潮首席科学家胡雷钧进行了先进技术报告演讲,他结合当前深度学习应用特点和先进计算技术架构进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJgj9p.html" rel="bookmark" class="title">一步一步学List Control控件的用法（第三步）----设置风格</a>
					<div>
						第三步  设置风格 1.  通过第一步和第二步,我们已经创建出了一个有一行并且有四列的内容的REPORT风格的List Control.可是,只是简单的方框中有一行数据而已,我们能不能让它们看起来更漂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNv1eM.html" rel="bookmark" class="title">《PHP精粹：编写高效PHP代码》&mdash;&mdash;导读</a>
					<div>
						目 录 第1章 面向对象编程1.1 为什么要使用面向对象编程1.2 OOP简介1.3 对象的继承1.4 对象和函数1.5 public.private以及protected1.6 接口1.7 异常1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1wLob.html" rel="bookmark" class="title">移动端脚本框架Hammer&period;js&lowbar;javascript技巧</a>
					<div>
						一.前言   移动端框架当前还处在初级阶段,但相对于移动端的应用来说已经有很长时间了.虽然暂时还没有PC端开发的需求量大,但移动端的Web必然是一种趋势,在接触移动端脚本的过程中,最开始想到的是juq ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Nmd9b.html" rel="bookmark" class="title">一个简单的实现下拉框多选的插件可移植性比较好&lowbar;jquery</a>
					<div>
						在使用上次写的一个多先下拉框时,我发现了很多问题,经过修改和完善后,现在已经能够很好地使用了,且可移植性也比较好,下面是源代码. js 复制代码 代码如下: (function(){ $.fn.ext ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYvk6b.html" rel="bookmark" class="title">Makeflow 3&period;3&period;3发布 工作流引擎</a>
					<div>
						Makeflow是一款执行大型复杂的应用程序的工作流引擎,它用于集群.云.网格的.它可以用来驱动几种不同的http://www.aliyun.com/zixun/aggregation/13452.h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVd9oBM.html" rel="bookmark" class="title">Google应用了跳过重定向的查询数</a>
					<div>
						摘要: 对于管理移动版网站(与桌面版网站使用不同的网址,例如移动版网站的网址为m.example.com,而桌面版网站的网址以www开头)的网站站长来说,网站站长工具中的搜索查询功能变得更有吸 对于管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAXJVp.html" rel="bookmark" class="title">松禾资本：四个领域可能出现伟大企业</a>
					<div>
						本报记者 屈红燕 在 纳斯达克制度的辅助下,硅谷的激情点燃了创新的浪潮,帮助美国经济取得了30年的增长,成就了微软等一批世界巨人.中国的创业板的大幕已经拉开,中国的&quot;微软&quot;将可能出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZm6kap.html" rel="bookmark" class="title">打车软件突围：民间智慧&OpenCurlyDoubleQuote;转正&rdquo;为上策</a>
					<div>
						晨报特派记者 张岂凡 北京报道一周国内聚焦在城市里打不到车怎么办? &quot;使用打车APP&quot;会是很多人首先给出的回答.在上海.北京.深圳等地,打车软件的兴起在一定程度上缓解了市民&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z43Gw9p.html" rel="bookmark" class="title">互联网开放平台未必能真正开放</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 如今中国的互联网正在一步一步的走向成熟化,人们把以往那些小家子气的秉性抛去变得大度.很多网络公司都认识到吸引用户的重要性,提高自身软件.程序.网站的用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqOvvYz.html" rel="bookmark" class="title">揭秘电商假货根源&lpar;惊心动魄呀~&rpar;</a>
					<div>
						揭秘电商 假货根源(惊心动魄呀~) 时间:2014-12-23 18:32 来源:互联网的一些事 作者:TR 12月23日 一些事 晚报 | 汇总今日最热资讯: 1.[IT公司在标识色彩(LOGO)选 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
